#ifdef i386
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <linux/types.h>
#include <linux/unistd.h>
#include <linux/dirent.h>
#include <errno.h>
#include <string.h>
#include <stdio.h>

_syscall3(int, readdir, uint, fd, struct dirent *, dirp, uint, count);
int readdir(unsigned int fd, struct dirent *dirp, unsigned int count);
_syscall3(int, getdents, uint, fd, struct dirent *, dirp, uint, count);
int getdents(unsigned int fd, struct dirent *dirp, unsigned int count);

inline void exit(x){
	_exit(x);
}
#endif

#ifdef NAME_MAX
#  define MAXNAMLEN    NAME_MAX
#else
#  define MAXNAMLEN    255
#endif

#ifndef i386
#define O_RDONLY	0
typedef long	off_t;
struct dirent
{
	long		d_ino;		/* inode number */
	off_t		d_off;		/* offset to next dirent */
	unsigned short	d_reclen;	/* length of this dirent */
	char		d_name[MAXNAMLEN+1]; /* file name (null-terminated) */
};
#endif

void puts2(char *s)
{
	char	*p, b[256];
	for(p = b; *s != 0;){
		*p++ = *s++;
	}
	*p++ = '\n';
	*p = '\0';
	write(1,b,p-b);
}

void puts3(char *s)
{
	char	*p, b[256];
	for(p = b; *s != 0;){
		*p++ = *s++;
	}
	*p++ = ':';
	*p++ = '\n';
	*p = '\0';
	write(1,b,p-b);
}

pdent(char *buf, unsigned long l)
{
	int	i;
	struct dirent *dentp;
#ifdef i386
	char	*p, *q;
#endif
	  /**/
#ifdef i386
	printf("len=%d\n",l);
#endif
	for(i = 0; i < l;){
		dentp = (struct dirent*)&buf[i];
#if 0
		printf("\n%4d\n",i);
		printf("long(%d)            d_ino       %x\n",sizeof(long),dentp->d_ino);
		printf("off_t(%d)           d_off       %x\n",sizeof(off_t),dentp->d_off);
		printf("unsigned short(%d)  d_reclen    %x\n",sizeof(unsigned short),dentp->d_reclen);
		printf("char(%d)            d_name[%3d] %p[%s]\n",sizeof(char),MAXNAMLEN+1,dentp->d_name,dentp->d_name);
		for(p = dentp->d_name, q = p + dentp->d_reclen; p < q; ++p){
			if(*p == '\0'){
				break;
			}
			printf(" %02x",*p);
		}
		printf("\n");
#endif
		puts2(dentp->d_name);
		i += dentp->d_reclen;
	}
}

#define TARGDIR "."

#if 0
extern printz(char* fmt,...);

#define printw(a...) do{printz(a);kaku(a);}while(0)

typedef void (*hoge_t)(void);
#endif

typedef unsigned long OBJECT_NAME;
typedef unsigned char UBYTE;
typedef long BYTE4;
typedef struct Queue_pbox{
	UBYTE  *data;		/* $B%G!<%?$X$N%]%$%s%?(B */
	BYTE4  size;		/* $B%G!<%?$N%5%$%:(B */
	BYTE4  timeout;		/* $B%?%$%`%"%&%H$N;~9o(B */
	OBJECT_NAME sender;	/* $B%G!<%?$NAw$j<g$NL>A0(B */
	BYTE4  when;		/* $BAw$j<g$,%G!<%?$r%-%e!<%$%s%0$7$?;~$N%7%9%F%`;~9o(B */
} QUEUE_PBOX;


int ls(char *path)
{
	int	fd, r;
	char	b[1024];
	  /**/
	if((fd = open(path, O_RDONLY)) < 0){
		puts2("open(5) failed");
		return -1;
	}
	if((r = getdents(fd, (struct dirent *)b, sizeof(b))) < 0){
		puts2("getdents(141) failed");
		return -1;
	}
	pdent(b,r);
	close(fd);
	return 0;
}

int
main(int argc, char** argv, char** envp)
{
	int	fd, r, i;
	struct dirent *dent;
	  /**/
	//puts2(__FILE__);
	//puts2("argv");
	//for(i = 0; i < argc; ++i){
	//	puts2(argv[i]);
	//}
	//puts2("envp");
	//while(*envp){
	//	puts2(*envp++);
	//}
	if(argc > 1){
		for(i = 1; i < argc; ++i){
			puts3(argv[i]);
			ls(argv[i]);
			write(1,"\n",1);
		}
	}else{
		ls(TARGDIR);
	}
	//puts2("End");
	return 0;
}
